#ifndef GME_INTERPRETER_H
#define GME_INTERPRETER_H

#include "Builder2000.h"

//enum rateGroup_t {None, 1Hz, 5Hz, 10Hz, 20Hz};
enum color_t {WHITE, GRAY, BLACK};
class CCompNode;
class CTaskNode;
class CProcessorNode;

typedef CTypedPtrList<CPtrList, CCompNode*> CCompNodeList;
typedef CTypedPtrList<CPtrList, CTaskNode*> CTaskNodeList;
typedef CTypedPtrList<CPtrList, CProcessorNode*> CProcessorNodeList;
//typedef CTypedPtrList<CPtrList, CMsgNode*> CMsgNodeList;
//typedef CTypedPtrList<CPtrList, CNetworkNode*> CNetworkNodeList;

class CCompNode {
public:
	int id;
	CString name;
	double wcet;
	int primaryPeriod, secondaryPeriod;
	color_t color;
	CCompNode *predecessor;
	CCompNodeList adjList;
	int processorID;
	bool isTimer;

	CCompNode(int id1, const char *name1, int processorID1, double wcet1): name(name1) {
		id = id1;
		processorID = processorID1;
		wcet = wcet1;
		primaryPeriod = -1;
		secondaryPeriod = -1;
		color = WHITE;
		isTimer = false;
	}
};

class CTaskNode {
public:
	int id;
	CString name;
	int period;
	int deadline;
	int priority;
	int processorID;
	double wcet;
	double wcrt;
	double previousWcrt;
	double blockingTime;
	double releaseJitter;
	bool timerTriggered;
	CTaskNodeList adjList;
	CCompNodeList compNodeList;
	

	CTaskNode(int id1, const char *name1, int processorID1, int period1, int priority1): name(name1) {
		id = id1;
		processorID = processorID1;
		period = period1;
		deadline = period1;
		priority = priority1;
		wcet = 0;
		blockingTime = 0;
		wcrt = 0;
		releaseJitter = 0;
		timerTriggered = false;
	}
};

class CProcessorNode {
public:
	int id;
	CString name;
	double cxtSwitchTime;
	double utilization;
	double utilizationBound;
	double maxSlowdownFactor;
	CTaskNodeList taskNodeList;

	CProcessorNode(int id1, const char *name1, double cxtSwitchTime1) {
		id = id1;
		name = name1;
		cxtSwitchTime = cxtSwitchTime1;
	}
};
/*
class CMsgNode {
public:
	int id;
	CString name;
	int size;

	CMsgNode(int id1, const char *name1, int size1) {
		id = id1;
		name = name1;
		size = size1;
	}
};

class CNetworkNode {
public:
	int id;
	CString name;
	int transmissionSpeed;
	double utilization;
	CMsgNodeList msgNodeList;

	CNetworkNode(int id1, const char *name1, int transmissionSpeed1) {
		id = id1;
		name = name1;
		transmissionSpeed = transmissionSpeed1;
	}
};
*/

#define NEW_BON_INVOKE
//#define DEPRECATED_BON_INVOKE_IMPLEMENTED

class CComponent {
public:
	CComponent() : focusfolder(NULL) { ; } 
	CBuilderFolder *focusfolder;
	CBuilderFolderList selectedfolders;
	void InvokeEx(CBuilder &builder,CBuilderObject *focus, CBuilderObjectList &selected, long param);
//	void Invoke(CBuilder &builder, CBuilderObjectList &selected, long param);
};

extern CCompNodeList gCompNodeList;
extern CTaskNodeList gTaskNodeList;
extern CProcessorNodeList gProcessorNodeList;
//extern CMsgNodeList gMsgNodeList;
//extern CNetworkNodeList gNetworkNodeList;


CProcessorNode *GetProcessorNodeByID(int id);

#endif // whole file
