// ComponentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "component.h"
#include "ComponentsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComponentsDlg dialog


CComponentsDlg::CComponentsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComponentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CComponentsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CComponentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComponentsDlg)
	DDX_Control(pDX, IDC_LIST_COMPONENTS, m_lcComponents);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CComponentsDlg, CDialog)
	//{{AFX_MSG_MAP(CComponentsDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComponentsDlg message handlers

BOOL CComponentsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ASSERT(m_TaskNode);	
	(void)m_lcComponents.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_lcComponents.SetHeadings( _T("Name, 100; WCET, 100"));
	m_lcComponents.LoadColumnInfo();

	CString name, wcet;
	POSITION pos = m_TaskNode->compNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = m_TaskNode->compNodeList.GetNext(pos);
		
		name = compNode->name;
		wcet.Format("%.2lf", compNode->wcet);
		int index = m_lcComponents.AddItem(name, wcet);
		m_lcComponents.SetItemData(index, (DWORD) compNode);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CComponentsDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_lcComponents.SaveColumnInfo();	
}
