// MainTaskDlg.cpp : implementation file
// CListCtrl LVITEM

#include "stdafx.h"
#include "component.h"
#include "MainTaskDlg.h"
#include "TaskDlg.h"
#include "RMA.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainTaskDlg dialog

void DisplayEDG();
void DisplayTaskGraph();

CMainTaskDlg::CMainTaskDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainTaskDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainTaskDlg)
	//}}AFX_DATA_INIT
}


void CMainTaskDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainTaskDlg)
	DDX_Control(pDX, IDC_BUTTON_VIEW_DETAILS, m_btnViewDetails);
	DDX_Control(pDX, IDC_LIST_TASK, m_lcProcessors);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainTaskDlg, CDialog)
	//{{AFX_MSG_MAP(CMainTaskDlg)
	ON_BN_CLICKED(IDC_BUTTON_VIEW_EDG, OnButtonViewEdg)
	ON_BN_CLICKED(IDC_BUTTON_VIEW_TG, OnButtonViewTg)
	ON_WM_DESTROY()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_TASK, OnDblclkListTask)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_TASK, OnItemchangedListTask)
	ON_BN_CLICKED(IDC_BUTTON_VIEW_DETAILS, OnButtonViewDetails)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainTaskDlg message handlers

BOOL CMainTaskDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
/*
	(void)m_lcProcessors.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_lcProcessors.SetHeadings( _T("Name,120;Date of Birth,90;Score,50") );
	m_lcProcessors.LoadColumnInfo();

	(void)m_lcProcessors.AddItem( _T("Mark Jackson"), _T("09/08/1974"), _T("100") );
	(void)m_lcProcessors.AddItem( _T("Trevor McSplatt"), _T("03/12/1970"), _T("25") );
	(void)m_lcProcessors.AddItem( _T("Sidney Finkelstein"), _T("01/01/1960"), _T("40") );
*/
	(void)m_lcProcessors.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_lcProcessors.SetHeadings( _T("CPU ID, 100;Num Tasks, 100; Util, 100; UtilBound, 100; CxtSwitch Time, 100"));
	m_lcProcessors.LoadColumnInfo();
	POSITION pos = gProcessorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *processorNode = gProcessorNodeList.GetNext(pos);
		CString processorID, numTasks, util, utilBound, cxtSwitchTime;
		processorID.Format("%d", processorNode->id);
		numTasks.Format("%d", processorNode->taskNodeList.GetCount());
		util.Format("%.2lf", processorNode->utilization);
		cxtSwitchTime.Format("%.2lf", processorNode->cxtSwitchTime);
		utilBound.Format("%.2lf", processorNode->utilizationBound);
    	int index = m_lcProcessors.AddItem( processorID, numTasks, util, utilBound, cxtSwitchTime);
		m_lcProcessors.SetItemData(index, (DWORD)processorNode);
	}

/*	(void)m_lcNetworks.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_lcNetworks.SetHeadings( _T("Network ID, 100; Num Msgs, 100; Util, 100"));
	m_lcNetworks.LoadColumnInfo();
*/
  /*	
	m_lcTasks.InsertColumn(0, "Name");
	m_lcTasks.InsertColumn(1, "CPU ID");
	m_lcTasks.InsertColumn(2, "Period");
	m_lcTasks.InsertColumn(3, "Priority");
	m_lcTasks.InsertColumn(4, "WCET");
	m_lcTasks.InsertColumn(5, "Successors");
	m_lcTasks.InsertColumn(6, "Task Util");
	m_lcTasks.InsertColumn(7, "CPU Util");
	m_lcTasks.InsertColumn(8, "CPU Util Bound");
	m_lcTasks.InsertColumn(9, "WCRT");

	m_lcTasks.SetColumnWidth(0, 100);
    m_lcTasks.SetColumnWidth(1, 50);
    m_lcTasks.SetColumnWidth(2, 50);
	m_lcTasks.SetColumnWidth(3, 50);
    m_lcTasks.SetColumnWidth(4, 50);
	m_lcTasks.SetColumnWidth(5, 100);
	m_lcTasks.SetColumnWidth(6, 50);
	m_lcTasks.SetColumnWidth(7, 50);
	m_lcTasks.SetColumnWidth(8, 50);
	m_lcTasks.SetColumnWidth(9, 50);

	POSITION pos = gTaskNodeList.GetHeadPosition();
	int i = 0;
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		CString processorID, period, WCET, successors, priority, taskUtil, CPUUtil, CPUUtilBound;
		processorID.Format("%d", taskNode->processorID);
		period.Format("%d", taskNode->period);
		priority.Format("%d", taskNode->priority);
		WCET.Format("%d", taskNode->wcet);
		taskUtil.Format("%lf", taskNode->utilization);
		CProcessorNode* processorNode = GetProcessorNodeByID(processorID);
		ASSERT(processorNode);
		CPUUtil.Format("%lf", processorNode->utilization);
		CPUUtilBound.Format("%lf", processorNode->utilizationBound);
		if(processorNode->utilization > processorNode->utilizationBound) {
			CString cs;
			cs.Format("The processor %d utilization %lf is larger than its bound %lf. The system is not schedulable",
				processorNode->utilization, processorNode->utilizationBound);
			AfxMessageBox(cs);
		}
		POSITION pos2 = taskNode->adjList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode2 = taskNode->adjList.GetNext(pos2);
			successors += taskNode2->name;
			successors += ",";
		}
		m_lcTasks.InsertRow(i++, 9, taskNode->name, processorID, period, priority, WCET, 
			successors, taskUtil, CPUUtil, CPUUtilBound);
	}
*/


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DisplayEDG() {
	CString cs("digraph G { \n label=\"File: c:\\temp\\comp.dot\"; \n size = \"11,7.75\"; \n orientation = landscape; \n");
/*
	POSITION pos = gCompNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = gCompNodeList.GetNext(pos);
		
		POSITION pos2 = compNode->adjList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode2 = compNode->adjList.GetNext(pos2);
			cs += compNode->name;
			cs += " -> ";
			cs += compNode2->name;
			cs += ";\n";
		}
	}
*/
	POSITION pos = gTaskNodeList.GetHeadPosition();
	int counter = 1;
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		cs += "subgraph ";
		CString temp;
		temp.Format("cluster%d", counter++);
		cs += temp;
		cs += "{\n";
		cs += "node [style=filled,color=white]; \n";
		cs += "style=filled;\n";
		cs += "color=blue;\n";
		cs += "label= \"";
		cs += taskNode->name;
		cs += "\"\n";

		POSITION pos2 = taskNode->compNodeList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode = taskNode->compNodeList.GetNext(pos2);
			cs += compNode->name;
			cs += ";\n";
		}
		cs += "}\n";
	}

	pos = gCompNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = gCompNodeList.GetNext(pos);
		POSITION pos2 = compNode->adjList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode2 = compNode->adjList.GetNext(pos2);
			cs += compNode->name;
			cs += " -> ";
			cs += compNode2->name;
			cs += ";\n";
		}
	}

	cs += "}";
	FILE *f = fopen("c:\\temp\\comp.dot", "w");
	ASSERT(f);
	fputs(cs, f);
	fclose(f);
	system("dotty c:\\temp\\comp.dot");
}
	

void DisplayTaskGraph() {
	CString cs("digraph G { \n label=\"File: c:\\temp\\task.dot\"; \n size = \"11,7.75\"; \n orientation = landscape; \n");

	POSITION pos = gProcessorNodeList.GetHeadPosition();
	int counter = 1;
	while(pos) {
		CProcessorNode *processorNode = gProcessorNodeList.GetNext(pos);
		cs += "subgraph ";
		CString temp;
		temp.Format("cluster%d", counter++);
		cs += temp;
		cs += "{\n";
		cs += "node [style=filled,color=white]; \n";
		cs += "style=filled;\n";
		cs += "color=blue;\n";
		cs += "label= \"";
		cs += processorNode->name;
		cs += "\"\n";

		POSITION pos2 = processorNode->taskNodeList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode = processorNode->taskNodeList.GetNext(pos2);
			cs += taskNode->name;
			cs += ";\n";
		}
		cs += "}\n";
	}

	pos = gTaskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		POSITION pos2 = taskNode->adjList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode2 = taskNode->adjList.GetNext(pos2);
			cs += taskNode->name;
			cs += " -> ";
			cs += taskNode2->name;
			cs += ";\n";
		}
	}
	cs += "}";
	FILE *f = fopen("c:\\temp\\task.dot", "w");
	ASSERT(f);
	fputs(cs, f);
	fclose(f);
	system("dotty c:\\temp\\task.dot");
}
	


void CMainTaskDlg::OnButtonViewEdg() 
{
	DisplayEDG();
}


void CMainTaskDlg::OnButtonViewTg() 
{
	DisplayTaskGraph();	
}
/*
void CMainTaskDlg::OnButtonAnalysis() 
{
	if(HolisticAnalysis()) {
		AfxMessageBox("RMA Analysis successful! Please view the task response times in the task details dialog.");
	} else {
		AfxMessageBox("RMA analysis unsuccessful! Some tasks are not schedulable.");
	}
}
*/

void CMainTaskDlg::OnDestroy() 
{
	m_lcProcessors.SaveColumnInfo();
//	m_lcNetworks.SaveColumnInfo(); 
	CDialog::OnDestroy();	
}

void CMainTaskDlg::OnDblclkListTask(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ShowProcessorDetails();	
	*pResult = 0;
}

void CMainTaskDlg::OnItemchangedListTask(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	m_btnViewDetails.EnableWindow(m_lcProcessors.GetSelectedCount() == 1);
	*pResult = 0;
}

void CMainTaskDlg::OnButtonViewDetails() 
{
	ShowProcessorDetails();	
}

void CMainTaskDlg::ShowProcessorDetails() 
{
	POSITION p = m_lcProcessors.GetFirstSelectedItemPosition();
	if(!p) return;
	while (p)
	{
		int nSelected = m_lcProcessors.GetNextSelectedItem(p);
		CTaskDlg dlg;
		dlg.m_ProcessorNode = (CProcessorNode *)m_lcProcessors.GetItemData(nSelected);
		ASSERT(dlg.m_ProcessorNode);
		dlg.DoModal();
	}
}
/*
void CMainTaskDlg::OnButtonViewSched() 
{
//	Tcl_Interp *interp = Tcl_CreateInterp();
//	(void) Tcl_EvalFile(interp, "e:\\mast\\xrma13.tcl");
}
*/
