// TaskDlg.cpp : implementation file
//

#include "stdafx.h"
#include "component.h"
#include "TaskDlg.h"
#include "ComponentsDlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTaskDlg dialog
void PrintTaskNode(FILE *dat, CTaskNode *taskNode);

CTaskDlg::CTaskDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTaskDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTaskDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTaskDlg)
	DDX_Control(pDX, IDC_BUTTON_VIEWE2E, m_btnViewE2E);
	DDX_Control(pDX, IDC_BUTTON_VIEW_COMPS, m_btnViewComps);
	DDX_Control(pDX, IDC_LIST_TASKS, m_lcTasks);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTaskDlg, CDialog)
	//{{AFX_MSG_MAP(CTaskDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_VIEW_COMPS, OnButtonViewComps)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_TASKS, OnDblclkListTasks)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_TASKS, OnItemchangedListTasks)
	ON_BN_CLICKED(IDC_BUTTON_VIEWE2E, OnButtonViewe2e)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTaskDlg message handlers

BOOL CTaskDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	(void)m_lcTasks.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_lcTasks.SetHeadings( _T("Name, 150; timerTriggered, 50; Priority, 50; Period, 50; WCET, 50; Util, 50; Deadline, 50; WCRT, 50; Schedulable, 50"));
	//m_lcTasks.SetHeadings( _T("Name, 150;  Priority, 50; Period, 50; WCET, 50; Util, 50; Deadline, 50; WCRT, 50; Schedulable, 50"));

	m_lcTasks.LoadColumnInfo();

	CString  name, timerTriggered, priority, period, wcet, util, deadline, wcrt, schedulable;
	POSITION pos = m_ProcessorNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *taskNode = m_ProcessorNode->taskNodeList.GetNext(pos);
		
		name = taskNode->name;
		priority.Format("%d", taskNode->priority);
		timerTriggered = taskNode->timerTriggered ? "Y" : "N";
		period.Format("%d", taskNode->period);
		wcet.Format("%.2lf", taskNode->wcet);
		util.Format("%.2lf", taskNode->wcet / taskNode->period);
		deadline.Format("%d", taskNode->deadline);
		wcrt.Format("%.2lf", taskNode->wcrt);
		schedulable = taskNode->wcrt <= taskNode->deadline ? "Y" : "N";
		int index = m_lcTasks.AddItem(name, timerTriggered, priority, period, wcet, util, deadline, wcrt, schedulable);
		//int index = m_lcTasks.AddItem(name, priority, period, wcet, util, deadline, wcrt, schedulable);
	
		m_lcTasks.SetItemData(index, (DWORD) taskNode);
	}
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTaskDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_lcTasks.SaveColumnInfo();	
}

void CTaskDlg::OnButtonViewComps() 
{
	ShowComponents();
}

void CTaskDlg::OnDblclkListTasks(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ShowComponents();	
	*pResult = 0;
}

void CTaskDlg::ShowComponents() {
	POSITION p = m_lcTasks.GetFirstSelectedItemPosition();
	ASSERT(p);
	while (p)
	{
		int nSelected = m_lcTasks.GetNextSelectedItem(p);
		CComponentsDlg dlg;
		dlg.m_TaskNode = (CTaskNode *)m_lcTasks.GetItemData(nSelected);
		ASSERT(dlg.m_TaskNode);
		dlg.DoModal();
	}
}


void CTaskDlg::OnItemchangedListTasks(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	m_btnViewComps.EnableWindow(m_lcTasks.GetSelectedCount() == 1);	
	m_btnViewE2E.EnableWindow(m_lcTasks.GetSelectedCount() == 1);	
/*	POSITION p = m_lcTasks.GetFirstSelectedItemPosition();
	if(!p) return;
	while (p)
	{
		int nSelected = m_lcTasks.GetNextSelectedItem(p);
		CTaskNode *taskNode = (CTaskNode *)m_lcTasks.GetItemData(nSelected);
		m_btnViewE2E.EnableWindow(taskNode->timerTriggered);
	}
*/	
	*pResult = 0;
}

void CTaskDlg::OnButtonViewe2e() 
{
	POSITION p = m_lcTasks.GetFirstSelectedItemPosition();
	if(!p) return;
	CTaskNode *taskNode;
	while (p)
	{
		int nSelected = m_lcTasks.GetNextSelectedItem(p);
		taskNode = (CTaskNode *)m_lcTasks.GetItemData(nSelected);
	}

	ASSERT(taskNode);
	if(!taskNode->timerTriggered) {
		AfxMessageBox("Please select a timer-triggered task to view timeline of the end-to-end transaction. ");
		return;
	}
	FILE *dat = fopen("c:\\temp\\mobies.dat", "w");
	ASSERT(dat);
	PrintTaskNode(dat, taskNode);
	fclose(dat);
	system("wish83 c:\\temp\\e2e.tcl");
}

void PrintTaskNode(FILE *dat, CTaskNode *taskNode) {
	fprintf(dat, "%s ", taskNode->name);
	fprintf(dat, "%d ", taskNode->deadline);
	fprintf(dat, "%.2lf ", taskNode->wcrt);
	fprintf(dat, "%.2lf\n", taskNode->wcet);

	POSITION pos = taskNode->adjList.GetHeadPosition();
	if(!pos) return;
	while(pos) {
		PrintTaskNode(dat, taskNode->adjList.GetNext(pos));
	}
}

